<?php
/*
Plugin Name: ICS Calendar
Plugin URI: http://www.fullimpact.net/blog/index.php/ics-calendar-plugin/
Author: <a href="http://www.fullimpact.net/">Daniel Olfelt</a>
Author URI: http://www.fullimpact.net/
Tags: calendar, events, ics, ical, icalendar, google
Version: v1.2.4
Description: A plugin for importing ICS files from Google or iCal into a blog page as an event list or calendar.
*/
ini_set('display_errors', 1); // FOR DEBUGING ONLY

require_once('import_ical.php');
//require_once('ical_parse.php');
require_once('ics-functions.php');
require_once('cal-functions.php');

$myabspath = str_replace("\\","/",ABSPATH);  // required for Windows & XAMPP
define('WINABSPATH', $myabspath);
define('ICSFOLDER', dirname(plugin_basename(__FILE__)));
//define('ICSCALENDAR_ABSPATH', $myabspath.'wp-content/plugins/' . ICSFOLDER .'/');
define('ICSCALENDAR_URLPATH', get_option('siteurl').'/wp-content/plugins/' . ICSFOLDER.'/');

define('ADMIN_OPTIONS_NAME',"ICSAdminOptions");

if (!class_exists("WPICSImporter")) {
	class WPICSImporter {
		var $adminOptionsName 			= "ICSAdminOptions";
		var $showCalendar				= "show-ics-calendar";
		var $showEvents					= "show-ics-events";
		function WPICSImporter() { //constructor
			
		}
		
		function init() {
			$this->getAdminOptions();
		}
		
		function getAdminOptions() {
			$ICSAdminOptions = array(
				'ics_file' 				=> '',
				'title' 				=> 'ICS Calendar',
				'event_limit'	 		=> '15',
				'time_format' 			=> 'g:i a',
				'date_format' 			=> 'D, M j',
				'custom_format' 		=> '',
				'gmt_start' 			=> '',
				'gmt_end' 				=> '',
				'gmt_start_now' 		=> 'true',
				'cache_time'	 		=> '3600',
				'enable_cache'	 		=> 'true',
				'use_custom_format' 	=> 'false',
				'widget_event_limit' 	=> '5',
				'widget_title' 			=> 'Upcoming Events',
				'calendar_num_events'	=> '2',
				'date_function'			=> 'date',
				'date_language'			=> '',
				/* CALENDAR SETTINGS */
				'cal_popups'			=> 'mouse-over',
				'cal_startday'			=> '0',
				'cal_permalinks'		=> '0'
				);
			$icsOptions = get_option(ADMIN_OPTIONS_NAME);
			if (!empty($icsOptions)) {
				foreach ($icsOptions as $key => $option)
					$ICSAdminOptions[$key] = $option;
			}
			update_option(ADMIN_OPTIONS_NAME, $ICSAdminOptions);
			
			return $ICSAdminOptions;
		}
		function printAdminPage() {
		
			global $wp_version;
		
			$icsOptions = $this->getAdminOptions();
			
			
			if (isset($_POST['update_ICSImporterSettings'])) {

				$icsOptions['ics_file'] = $_POST['icsFile'];
				$icsOptions['title'] = $_POST['icsTitle'];
				$icsOptions['event_limit'] = $_POST['icsEventLimit'];
				$icsOptions['cache_time'] = $_POST['icsCacheTime'];
				$icsOptions['enable_cache'] = $_POST['icsEnableCache'];
				$icsOptions['time_format'] = $_POST['icsTimeFormat'];
				$icsOptions['date_format'] = $_POST['icsDateFormat'];
				$icsOptions['gmt_start'] = $_POST['icsGmtStart'];
				$icsOptions['gmt_end'] = $_POST['icsGmtEnd'];
				$icsOptions['gmt_start_now'] = $_POST['icsGmtStartNow'];
				$icsOptions['custom_format'] = $_POST['icsCustomFormat'];
				$icsOptions['use_custom_format'] = $_POST['icsUseCustomFormat'];
				$icsOptions['calendar_num_events'] = $_POST['icsCalendarNumEvents'];
				$icsOptions['date_language'] = $_POST['icsDateLanguage'];
				$icsOptions['date_function'] = $_POST['icsDateFunction'];
				
				/* CALENDAR OPTIONS */
				$icsOptions['cal_popups'] = $_POST['icsCalPopups'];
				$icsOptions['cal_startday'] = $_POST['icsCalStartDay'];
				$icsOptions['cal_permalinks'] = $_POST['icsCalPermalinks'];
				
				if(class_exists('ICalEvents')) {
					$ics_load_error = ICalEvents::update_cache($icsOptions['ics_file']);
				}
				
				update_option($this->adminOptionsName, $icsOptions);
				
				?>
				<div class="fade updated" id="message"><p><strong><?php _e("Settings Updated.", "WPICSImporter");?></strong></p></div>
				<?php
			}
			foreach($icsOptions as $key=>$item) { $icsOptions[$key] = stripslashes($item); }
			?>
			<style type="text/css">
				.form-table th { white-space:nowrap; }
				<?php if($wp_version < "2.5") { ?>
				.form-table { width:100%; }
				.form-table td { padding:10px; border-bottom:10px solid #FFFFFF; }
				.form-table tr { background:#EFEFEF; }
				.form-table th { border-bottom:10px solid #FFFFFF; text-align:left; padding:10px 25px 0 10px; }
				
				.ui-tabs-nav { margin:0 -13px 0 -13px; }
				.ui-tabs-nav .ui-tabs-selected a { color:#000000; font-weight:bold; }
				<?php } ?>
			</style>
			<script type="text/javascript">
				jQuery(function() {
					jQuery('#tab_holder > ul').tabs();
					//jQuery('#tab_holder').tabs({ fx: { opacity: 'toggle' } });
				});
			</script>
			<div style="width:100%;">
				<div class="wrap">
					<h2>ICS Calendar</h2>
				<?php if($wp_version >= "2.5") { print "</div>"; } ?>
				<br />
				<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
				<div id="tab_holder">
					<ul id="tabs">
						<li><a href="#general_settings">General Settings</a></li>
						<li><a href="#format_settings">Formatting</a></li>
						<li><a href="#calendar_settings">Calendar</a></li>
					</ul>
					<div id="general_settings">
						<div<?php if($wp_version >= "2.5") { print ' class="wrap"'; } ?>>
						<table class="form-table">
							<tr valign="top">
							<th scope="row" width="100">Calendar Title</th>
							<td>
								<input type="text" name="icsTitle" style="width: 250px; " value="<?php _e(stripslashes($icsOptions['title']), 'WPICSImporter') ?>" />
							</td></tr>
							<tr valign="top"><th scope="row">URL to ICS File</th>
								<td>
								<input type="text" name="icsFile" style="width: 90%; " value="<?php _e($icsOptions['ics_file'], 'WPICSImporter') ?>" />
								<?php if(isset($ics_load_error)) echo '<br /><font color="#CC0000">'.$ics_load_error.'</font>'; ?>
								</td></tr>
							<tr valign="top"><th scope="row">Cache Calendar File</th>
								<td>
								<label><input type="checkbox" name="icsEnableCache" value="true" <?php if ($icsOptions['enable_cache'] == "true") { _e('CHECKED', "WPICSImporter"); }?> /> Enable caching to save the .ics file on my server.</label>
								<br /><small>The .ics file will be updated once per day. You can update it manually by clicking "Save Changes."</small>
								<!--<input disabled="disabled" type="text" name="icsCacheTime" style="width: 10%; " value="<?php _e($icsOptions['cache_time'], 'WPICSImporter') ?>" /> Seconds
								&nbsp;&nbsp;&nbsp;&nbsp;<small>Set to 1 hour. [Feature coming soon.]</small>-->
								</td></tr>
							<tr valign="top"><th scope="row">Event Display Limit</th>
								<td>
									<input type="text" name="icsEventLimit" style="width: 10%; " value="<?php _e($icsOptions['event_limit'], 'WPICSImporter') ?>" /> Set to "0" to show all events.
								</td></tr>
							<tr valign="top">
								<th scope="row">Current Event Display</th>
								<td>
								<label><input type="checkbox" id="icsGmtStartNow_yes" name="icsGmtStartNow" value="true" <?php if ($icsOptions['gmt_start_now'] == "true") { _e('CHECKED', "WPICSImporter"); }?> /> Show only upcoming event. (Only events in the future.)</label>
								<br />
								From <input type="text" name="icsGmtStart" style="width: 100px; " value="<?php _e($icsOptions['gmt_start'], 'WPICSImporter') ?>" /> to
								<input type="text" name="icsGmtEnd" style="width: 100px; " value="<?php _e($icsOptions['gmt_end'], 'WPICSImporter') ?>" />
								<br /><small>Use format 'YYYY-MM-DD' or 'YYYY-MM-DD HH:MM:SS'. This is irrelevant if the Upcoming Events box is checked. Leave these blank if you want to show all events.</small>
								</td></tr>
							<tr><td colspan="2">
								To use this on a <b>Page</b>, enter <b>[show-ics-events]</b> or <b>[show-ics-events=<i>num_events</i>]</b> on a page. This will be replaced by the events list.
							</td></tr>
						</table>
						</div>
					</div>
					<div id="format_settings">
						<div<?php if($wp_version >= "2.5") { print ' class="wrap"'; } ?>>
						<table class="form-table">
							<tr valign="top"><th scope="row" width="100">Formatting</th>
								<td>
								<input type="text" name="icsDateFormat" style="width: 20%; " value="<?php _e($icsOptions['date_format'], 'WPICSImporter') ?>" /> <b><?php echo ICalEvents::fdate($icsOptions['date_format'], time()); ?></b>
								<br /><small>Uses PHP <a target="_blank" href="http://us3.php.net/manual/en/function.date.php">Date Function</a> or <a href="http://us2.php.net/manual/en/function.strftime.php" target="_blank">strftime Function</a>.</small>
								</td></tr>
							<tr valign="top"><th scope="row">Time Format</th>
								<td>
								<input type="text" name="icsTimeFormat" style="width: 20%; " value="<?php _e($icsOptions['time_format'], 'WPICSImporter') ?>" /> <b><?php echo ICalEvents::fdate($icsOptions['time_format'], time()); ?></b>
								<br /><small>Uses PHP <a target="_blank" href="http://us3.php.net/manual/en/function.date.php">Date Function</a> or <a href="http://us2.php.net/manual/en/function.strftime.php" target="_blank">strftime Function</a>.</small>
								</td></tr>
							<tr valign="top"><th scope="row">Custom Event Format</th>
								<td>
									<p>Use custom format? <label><input type="radio" name="icsUseCustomFormat" value="true" <?php if ($icsOptions['use_custom_format'] == "true") { _e('checked="checked"', "WPICSImporter"); }?> onclick="if(this.checked==true) { document.getElementById('ics_custom_format').style.display='block'; }" /> Yes</label>
										<label><input type="radio" name="icsUseCustomFormat" value="false" <?php if ($icsOptions['use_custom_format'] == "false") { _e('checked="checked"', "WPICSImporter"); }?> onclick="if(this.checked==true) { document.getElementById('ics_custom_format').style.display='none'; }" /> No</label></p>
								<div id="ics_custom_format" style="display:<?php print (($icsOptions['use_custom_format'] == "false") ? 'none' : 'block'); ?>; ">
									<h5 style="margin-bottom:0;">Set Custom Format</h5>
									<textarea name="icsCustomFormat" style="width: 90%; height:100px; "><?php _e($icsOptions['custom_format'], 'WPICSImporter') ?></textarea>
									<br />Use <i>%date-time%</i>, <i>%event-title%</i>, <i>%description%</i> and <i>%location%</i>.
								</div>
							</td></tr>
							<tr valign="top"><th scope="row">Date Function</th>
								<td>
								<select name="icsDateFunction" style="width: 20%; " >
									<option value="strftime" <?php if($icsOptions['date_function']=='strftime') echo ' selected="selected"'; ?>>Strftime Function</option>
									<option value="date" <?php if($icsOptions['date_function']=='date') echo ' selected="selected"'; ?>>Date Function</option>
								</select>
								<br /><small>Uses PHP <a target="_blank" href="http://us3.php.net/manual/en/function.date.php">Date Function</a> or <a href="http://us2.php.net/manual/en/function.strftime.php" target="_blank">strftime Function</a>.</small>
								</td></tr>
							<tr valign="top"><th scope="row">Date Locale (Language)</th>
								<td>
								<input type="text" name="icsDateLanguage" style="width: 20%; " value="<?php _e($icsOptions['date_language'], 'WPICSImporter') ?>" />
								<br /><small>Use a comma to seperate multiple locales. This can only be used if the date function is set to 'strftime'.</small><br />
								<?php 
									ob_start();
									system('locale -a');
									$locales = ob_get_contents();
									ob_end_clean();
									
									$local = explode("\n",$locales);
									echo '<a href="javascript:void(0);" onclick="jQuery(\'#supported_locales\').toggle();">Show / Hide Supported Locales</a> - Only works on Linux';
									echo '<div id="supported_locales" style="display:none; font-size:10px; ">';
									foreach($local as $key=>$val) {
										echo $val." | \n";
									}
									echo '</div>';
									?>
								</td></tr> 
						</table>
						</div>
					</div>
					<div id="calendar_settings">
						<div<?php if($wp_version >= "2.5") { print ' class="wrap"'; } ?>>
						<table class="form-table">
							<tr valign="top"><th scope="row">Show Calendar Popups</th>
								<td>
								<select name="icsCalPopups" style="width: 20%; " >
									<option value="none" <?php if($icsOptions['cal_popups']=='none') echo ' selected="selected"'; ?>>Never</option>
									<option value="mouse-over" <?php if($icsOptions['cal_popups']=='mouse-over') echo ' selected="selected"'; ?>>On Mouse Over</option>
									<option value="click" <?php if($icsOptions['cal_popups']=='click') echo ' selected="selected"'; ?>>On Click</option>
								</select>
								<br /><small>When to show the popups</small>
								</td></tr>
							<tr valign="top"><th scope="row">Calendar Start Day</th>
								<td>
								<select name="icsCalStartDay" style="width: 20%; " >
									
									<?php 
									$cal_days = array('0'=>'Sunday', '1'=>'Monday', '2'=>'Tuesday', '3'=>'Wednesday', '4'=>'Thursday', '5'=>'Friday', '6'=>'Saturday');
									foreach($cal_days as $key=>$value) {
										echo '<option value="'.$key.'" ' . ( ($icsOptions['cal_startday']==$key) ? ' selected="selected"' : '' ) . '>'.$value.'</option>'."\n";
									} ?>
								</select>
								<br /><small>What day of the week would you like the calendar to start on?</small>
								</td></tr>
							<tr valign="top"><th scope="row">Show Calendar Permalinks</th>
								<td>
                                <label><input type="radio" name="icsCalPermalinks" value="0" <?php if($icsOptions['cal_permalinks']=='0') echo ' checked="checked"'; ?>/> Hide</label>
                                <label><input type="radio" name="icsCalPermalinks" value="1" <?php if($icsOptions['cal_permalinks']=='1') echo ' checked="checked"'; ?>/> Show</label>
								<br /><small>Whether or not to show permalinks in the calendar popups.</small>
								</td></tr>
						<tr><td colspan="2">
							To use this on a <b>Page</b>, enter <b>[show-ics-calendar]</b> on a page. This will be replaced by the calendar.
						</td></tr></table>
						</div>
					</div>
				</div>
				<div<?php if($wp_version >= "2.5") { print ' class="wrap"'; } ?>>
					<div class="submit"><input type="submit" name="update_ICSImporterSettings" value="<?php _e('Save Changes', 'WPICSImporter') ?>" /></div>
				</div>
				</form>
				<?php if($wp_version < "2.5") { print "</div>"; } ?>
			</div>
			<?php
		}
		
		function placePageCalendar($content) {
			// Only do this if this is a page and it has the appropriate custom field
			if (is_page()) {

				$icsOptions = $this->getAdminOptions();
				
				// SET PAGE LOCALE
				if(!empty($icsOptions['date_language'])) {
					$fixed_locales = preg_replace('/ +/','',$icsOptions['date_language']);
					$locales = explode(',',$fixed_locales);
					if(!setlocale(LC_ALL, $locales)) {
						//return "Locale Error";
						exit;
					}
				}
				
				$custFieldValues = get_post_custom_values($this->showEvents);
				if ($custFieldValues != NULL || eregi('\['.$this->showEvents.'=?([0-9]*)?\]',$content,$args)) {
					if(isset($args[1])) $icsOptions['event_limit'] = $args[1];
					
					if($icsOptions['use_custom_format']=='true') {
						$eventsContent = ICalEvents::custom_display_events($icsOptions);
					} else {
						if($icsOptions['gmt_start_now']=='true') {
							$gmt_start = time();
							$gmt_end = NULL;
						} else {
							if($options['gmt_start']!='') $gmt_start = strtotime($options['gmt_start'], time());
							if($options['gmt_end']!='') $gmt_end = strtotime($options['gmt_end'], time());
						}
						define('ICAL_EVENTS_CACHE_TTL', $icsOptions['cache_time']);
						$eventsContent = ICalEvents::display_events($icsOptions['ics_file'], 'limit='.$icsOptions['event_limit'].'&date_format='.$icsOptions['date_format'].'&time_format='.$icsOptions['time_format'].'&use_description=1&use_location=1&gmt_start='.$gmt_start.'&gmt_end='.$gmt_end);
					}
					if(eregi('\['.$this->showEvents.'=?([0-9]*)?\]',$content)) {
						$content = eregi_replace('\['.$this->showEvents.'(=[0-9]*)?\]',$eventsContent,$content);
					} else {
						$content = $eventsContent;
					}
				}
				if(eregi('\['.$this->showCalendar.'\]',$content)) {
					$calDisplay = '<style type="text/css" media="screen">@import "'.ICSCALENDAR_URLPATH.'library/ics-calendar.css";</style>'."\n";
					$eventid = '';
					if(!empty($_GET['icsevent'])) $eventid = $_GET['icsevent'];
					if(!empty($_GET['icsdate'])) $eventdate = $_GET['icsdate'];
					$calDisplay .= icsCalDisplay::initCalendar($icsOptions, $eventid, $eventdate);
					$content = eregi_replace('\['.$this->showCalendar.'\]',$calDisplay, $content);
				}
			}
			return $content;
		}
		
		function addHeader() {
			global $wp_version;
			echo '<!-- Running Wordpress Version '.$wp_version.' -->';
			//echo "\n".'<style type="text/css" media="screen">@import "'.ICSCALENDAR_URLPATH.'library/ics-calendar.css";</style>'."\n";
			if ($wp_version < "2.5") {
				if ($wp_version > "2.1.3") wp_deregister_script('jquery'); 
				wp_enqueue_script('jquery', ICSCALENDAR_URLPATH .'library/jquery-1.2.3.js', FALSE, '1.2.3');
			}
		}
		function addUserHeader() {
			$this->addHeader();
			wp_enqueue_script('jquery', ICSCALENDAR_URLPATH .'library/jquery-1.2.3.js', FALSE, '1.2.3');
			/*echo '<script type="text/javascript">var jQuery = window.jQuery = function( selector, context ) { return new jQuery.prototype.init( selector, context ); }; window.$ = jQuery; </script>'; //*/
		}		
		function addAdminHeader() {
			if(isset($_GET['page']) && $_GET['page']=='ics-import.php') {
				//$this->addHeader();
				echo "\n".'<style type="text/css" media="screen">@import "'.ICSCALENDAR_URLPATH.'library/ui.tabs.css";</style>'."\n";
			}
		}
		
		function addAdminHeaderJS() {
			global $wp_version;
			if(isset($_GET['page']) && $_GET['page']=='ics-import.php') {
				if ($wp_version < "2.5") {
					wp_deregister_script('jquery'); 
					wp_register_script('jquery', ICSCALENDAR_URLPATH .'library/jquery-1.2.3.js', FALSE, '1.2.3');
				} 
				//wp_enqueue_script('jquery2', ICSCALENDAR_URLPATH .'library/jquery-1.2.3.js', FALSE, '1.2.3');
				wp_enqueue_script('jquery-tabs', ICSCALENDAR_URLPATH .'library/jquery.ui.tabs.pack.js', array('jquery'), '2.7.4');
			}
		}
		
		### SIDEBAR WIDGET COMPILE INFORMATION
		
		function widgetICSImporterInit() {
			if (!function_exists('register_sidebar_widget')) { return; }
			
			//$options = $this->getAdminOptions();
			
			function widgetICSImporter($args) {
				global $dl_pluginICS;
				extract($args, EXTR_SKIP);
				
				if (!isset($dl_pluginICS)) { return; }
				
				if(!$widget = get_option('ICSWidgetOptions')) $widget = array('widget_event_limit'=>'5', 
																			  'widget_title'=>'Upcoming Events', 
																			  'widget_link'=>'', 
																			  'date_format'=>'', 
																			  'time_format'=>'',
																			  'custom_format'=>'',
																			  'hide_time'=>'',
																			  'gmt_start_now'=>'true');
				
				
				$options = $dl_pluginICS->getAdminOptions();
				
				foreach($widget as $key=>$item) { $widget[$key] = stripslashes($item); }
				foreach($options as $key=>$item) { $options[$key] = stripslashes($item); }
				
				$options['event_limit'] = $widget['widget_event_limit'];
				$options['use_custom_format'] = 'false';
				$options['hide_time'] = $widget['hide_time'];
				
				if($widget['date_format']!='') $options['date_format'] = $widget['date_format'];
				if($widget['time_format']!='') $options['time_format'] = $widget['time_format'];
				if($widget['gmt_start_now']=='true') $options['gmt_start_now'] = 'true';
				
				if($widget['custom_format']!='') $options['custom_format'] = $widget['custom_format'];
					else $options['custom_format'] = '<li style="color:#333333; "><b>%date-time%:</b>%event-title%</li>';
				
				print $before_widget . $before_title;
				print $widget['widget_title'];	
				print $after_title;
				echo '<ul>';
				print ICalEvents::custom_display_events($options);
				if($widget['widget_link']!='') {
					print '<small><a href="'.$widget['widget_link'].'">More &raquo;</a></small>';
				}
				print "</ul>".$after_widget;
				
			}
			
			function widgetICSImporterOptions()
			{
		
				//$options = $this->getAdminOptions();
				if(!$options = get_option('ICSWidgetOptions')) $options = array('widget_event_limit'=>'5', 
																				'widget_title'=>'Upcoming Events', 
																				'widget_link'=>'', 
																				'date_format'=>'', 
																				'time_format'=>'',
																				'hide_time'=>'',
																			  	'custom_format'=>'',
																				'gmt_start_now'=>'true');
				
				if($_POST['icsImporterSubmit'])
				{
					$options['widget_event_limit'] = $_POST['icsWidgetEventLimit'];
					$options['widget_title'] = $_POST['icsWidgetTitle'];
					$options['date_format'] = $_POST['icsWidgetDateFormat'];
					$options['time_format'] = $_POST['icsWidgetTimeFormat'];
					$options['custom_format'] = $_POST['icsCustomFormat'];
					$options['widget_link'] = $_POST['icsWidgetLink'];
					$options['hide_time'] = $_POST['icsWidgetHideTime'];
					$options['gmt_start_now'] = $_POST['icsWidgetGmtStartNow'];
					update_option('ICSWidgetOptions', $options);
		
				}
				foreach($options as $key=>$item) { $options[$key] = stripslashes($item); }
				?>
		
				<p>Title: <input type="text" name="icsWidgetTitle" value="<?php echo $options['widget_title']; ?>" id="icsWidgetTitle" /></p>
				<p>Event Limit: <input type="text" name="icsWidgetEventLimit" value="<?php echo $options['widget_event_limit']; ?>" id="icsWidgetEventLimit" /></p>
				<label for="icsWidgetGmtStartNow_checked"><input type="checkbox" id="icsWidgetGmtStartNow_checked" name="icsWidgetGmtStartNow" value="true"<?php if ($options['gmt_start_now'] == "true") { echo ' CHECKED'; }?> /> Show upcoming events only.</label>
				<p>Date Format: <input type="text" name="icsWidgetDateFormat" value="<?php echo $options['date_format']; ?>" id="icsWidgetDateFormat" /><br />
				<small>Default will be used if not set.</small></p>
				<p>Time Format: <input type="text" name="icsWidgetTimeFormat" value="<?php echo $options['time_format']; ?>" id="icsWidgetTimeFormat" /><br />
				<label><input type="checkbox" name="icsWidgetHideTime" value="true"<?php if ($options['hide_time'] == "true") { echo ' CHECKED'; }?> /> Do not display time.</label>
				<br /><small>Default will be used if not set.</small></p>
				<p>Bottom Link: <input type="text" name="icsWidgetLink" value="<?php echo $options['widget_link']; ?>" id="icsWidgetLink" /><br />
				<small>Will be used at the bottom of the events.</small></p>
				<p>Custom Event Format:<br />
				<textarea name="icsCustomFormat" style="width:100%; font-size:10px; " rows="4"><?php echo $options['custom_format']; ?></textarea>
				</p>
				<input type="hidden" id="icsImporterSubmit" name="icsImporterSubmit" value="1" />
				
				<?php
		
			}
			register_sidebar_widget('ICS Calendar', 'widgetICSImporter');
			register_widget_control('ICS Calendar', 'widgetICSImporterOptions', 300, 300);
		}
	
	}
}

if (class_exists("WPICSImporter")) {
	$dl_pluginICS = new WPICSImporter();
}

//Actions and Filters
if (isset($dl_pluginICS)) {
	if (!function_exists("ICSImporter_ap")) {
		function ICSImporter_ap() {
			global $dl_pluginICS;
			if (!isset($dl_pluginICS)) {
				return;
			}
			if (function_exists('add_options_page')) {
				add_options_page('ICS Calendar', 'ICS Calendar', 9, basename(__FILE__), array(&$dl_pluginICS, 'printAdminPage'));
			}
		}
	}
	//Actions
	add_action('init',  array(&$dl_pluginICS, 'addAdminHeaderJS'), 1);
	add_action('wp_head',  array(&$dl_pluginICS, 'addUserHeader'), 1);
	add_action('admin_head',  array(&$dl_pluginICS, 'addAdminHeader'), 1);
	add_action('admin_menu', 'ICSImporter_ap');
	add_action('activate_ical-events/ical-events.php',  array(&$dl_pluginICS, 'init'));
	add_action('plugins_loaded', array(&$dl_pluginICS, 'widgetICSImporterInit'));
	//add_action('wp_head', array(&$dl_pluginICS, 'addHeaderCode'), 1);
	//Filters
	add_filter('the_content', array(&$dl_pluginICS, 'placePageCalendar'), '7');
}


?>